;****    16x1  16x2  PIC16F628 (v3.1) ****
; RA4NAL  28.09.2012

  errorlevel 0, -302

Type set 1   ; '1' -   16x1, '2' -  16x2

;                                         MSB     LSB
;___xxx.xx0,00_KH  0,1s   .    00000000.01000100     00      44
;__xxx.xxx.xx0_Hz    1s   .    00000000.10001000     00      88
;xxx.xxx.xx0,0_Hz   10s   .    00000010.00100010     02      22
;__x.xxx.xx0,0_KH  0,1s  1...20      00000010.00100010     02      22
;_x.xxx.xx0,00_KH    1s  1...20      00000100.01000100     04      44
;x.xxx.xxx.xx0_Hz   10s  1...20      00001000.10001000     08      88
;___xx.xxx.xx0_KH  0,1s 21...256     00000000.10001000     00      88
;_xx.xxx.xx0,0_KH    1s 21...256     00000010.00100010     02      22
;xx.xxx.xx0,00_KH   10s 21...256     00000100.01000100     04      44
;_Hz
;_KH
;_MH
;_GH
;  
;      . 1...20  21...256   
;0,1s   10Hz   100Hz   1000Hz      (1,2,3)
;  1s    1Hz    10Hz    100Hz      (4,5,6)
; 10s  0,1Hz     1Hz     10Hz      (7,8,9)

; 
; RA0 - OUT     E  Ind
; RA1 - OUT    A0  Ind
; RA2 - IN/OUT LED
; RA3 - IN/OUT IN F
; RA4 - IN     IN F
; RA5 - MCLR
; RA6 - CLKOUT
; RA7 - CLKIN
; RB0 - IN     1 | 
; RB1 - IN     2 | 
; RB2 - IN     1 | Del
; RB3 - IN     2 | Del
; RB4 - IN/OUT 0,1s (SB1) / DB4 Ind
; RB5 - IN/OUT   1s (SB2) / DB5 Ind
; RB6 - IN/OUT  10s (SB3) / DB6 Ind
; RB7 - IN/OUT  DB7 Ind

;  EEPROM
; 00 -
; 01: 111111xx  - : FD-1s  FC-0,1s  FE,FF-10s
; 02: . . 
; 03: . . 
; 04: .  
; 05: Kd1
; 06: Kd2
; 07: Kd3
;                             
;                              /
; 08   09   0A   0B - 1-  0001xxxx
; 0C   0D   0E   0F - 2-  0010xxxx
; 10   11   12   13 - 3-  0011xxxx

; 
CONZAD    EQU 20H      ; . .  
DOPCON    EQU 2EH      ; 46 -    .

MAXINT    EQU 040H     ; Max  .    
MININT    EQU 004H     ; Min  .    

;  
         cblock 20H
MEMSZ      ;* (0-255) . . 
MEMLZ      ;* (0-255) . . 
MEMTZ      ;* (0-31)  . . 
MEMTIME    ;* (1, 10, 100) - .  0,1
TMP1       ;   .
TMP2       ; ///
TMP3       ; ///
TMP4       ; ///
MEML0      ; .   
MEML1
MEML2
MEML3
MEML4
MEML5
MEML6
MEML7
MEML8
MEML9
MEMLA
MEMLB
MEMLC
MEMLD
MEMLE
MEMLF      ; .   
StrHi      ;    
StrLow     ; /
KNOLD      ;* . . . .  .
KNNEW      ;* . . .   .
MEMADR     ;   EEPROM  
MEM18      ;    .
MEM19      ; .  1-   -, 2-. . F
MEM20
MEM21
MEM22
MEM23      ; .  1-   -, 2-. . F
MEM28      ;*  ()
MEM29      ;* .   
MEM30      ;* /
MEM31      ;* /
IF1        ;*   .  ,  B7=0 --> +
;                             B7=1 --> -
IF2        ;* /
IF3        ;* /
IF4        ;* /
FLAGS      ;* . 
          endc

;   FLAGS
BIT0      EQU  0   ;   =0 --> 0,1,          =1 --> 1
BIT1      EQU  1   ;   =0 --> 0,1  1, =1 --> 10
BIT2      EQU  2   ;   =0 -->  .,      =1 -->  .

LED       EQU  02H ;    PORTA,LED

#define  PIN_ELCD   PORTA,0
#define  PIN_A0LCD  PORTA,1

        LIST P=16F628A
        INCLUDE p16f628A.inc

;************   PIC16F628A *************
; bit1-0   =01 (XT)
; bit4     =0  (XT)
; bit2 - WDTE=0  (WDTE  disabl)
; bit3 - PWRTE=0 (PWRTE enable)
; bit5     =1  (MCLR)
; bit6     =1  (BOD enable)
; bit7     =0  (LVP disable)
; bit8-13  =1  (Code protect off)

     __CONFIG  3F61H     ; B'11.1111.0110.0001

       ORG 0000H
;******************   ********************
       goto    INIT

       ORG 0004H

INIT:  clrf   STATUS
       clrf   PCLATH
       clrf   INTCON      ;  
       clrf   T1CON       ;  TMR1,  1:1
       clrf   T2CON       ;  TMR2
       clrf   CCP1CON     ; CCP .
       clrf   RCSTA
       MOVLW  07H
       MOVWF  CMCON       ; . 
       MOVLW  00H
       MOVWF  PORTA
       bsf    STATUS,RP0  ; 1 .
       MOVLW  0FCH        ; 1111.1100
       MOVWF  TRISA       ; RA0,1 - OUT
       MOVLW  0FFH
       MOVWF  TRISB       ; PORTB - IN
       movlw  077H        ; 0117.0111
       movwf  OPTION_REG  ; pull-ups, 1/256 |_ RA4
       clrf   PIE1        ;  .
       clrf   VRCON
       clrf   TXSTA       ; UART disable
       clrf   EECON1      ;  EEPROM
       bcf    STATUS,RP0  ; 0 .
       movlw  40H         ;  50ms  4mhz
       movwf  TMP1
       call   ZAD101
;  EEPROM  
       clrf    MEML0      ;   EEPROM
       movlw   02H        ;  . . . .
       call    RD01       ;  . . . .
       movwf   TMP1       ; 
       sublw   MAXINT     ; MAXINT-(.. ) --> W
       btfss   STATUS,C   ; ,  <= MAXINT
       goto    INIT1      ;   
       movf    TMP1,W
       sublw   MININT     ; MININT-(.. ) --> W
       btfss   STATUS,C   ; ,  <= MININT,   
       goto    INIT2
INIT1: CALL    WRSET      ;  EEPROM  
       incf    MEML0,F    ;   
INIT2: CALL    RDB1       ;   
       MOVLW   01         ;  
       CALL    RD01       ; 
       MOVWF   FLAGS
       CALL    INDPRD     ;  
;  
       call    LCDInit    ;  
       movf    MEML0,F
       btfss   STATUS,Z   ;   EEPROM
       goto    INIT3      ;   
       movlw   HIGH Zastawka
       movwf   StrHi
       movlw   LOW Zastawka
       movwf   StrLow
       goto    INIT4
INIT3: movlw   HIGH ConstErr
       movwf   StrHi
       movlw   LOW ConstErr
       movwf   StrLow
INIT4: call    Out1Str    ;  
; 
       BTFSC   FLAGS,BIT1 ; 1  0,1
       GOTO    INIT5      ; 10
       movlw   .100
       call    ZAD_N10    ; . 1
       BTFSC   FLAGS,BIT0 ; 0,1
       goto    INIT5      ; 1
       movlw   .100
       call    ZAD_N10    ;  1  . 0,1
INIT5: MOVLW   64H        ; 100,  10
       BTFSC   FLAGS,BIT1 ;  1  0,1
       GOTO    BGN3       ;  10
       MOVLW   0AH        ;  1
       BTFSS   FLAGS,BIT0 ;  1
       MOVLW   01         ;  0,1
BGN3:  MOVWF   MEMTIME    ; -  0,1
       CLRF    KNOLD      ; . . .  .
BEGN:  COMF    PORTB,W    ; . . 0-., 1-.
       MOVWF   KNNEW
BGN1:  MOVWF   TMP1
       IORLW   8FH        ; 1000.1111B -  3- 
       ADDLW   01         ; W+1-->W
       BTFSC   STATUS,Z   ; ,  W  0
       GOTO    NSTR       ;  3 .,   .
       MOVF    TMP1,W
       ANDLW   70H        ; 0111.0000B -  3- 
       BTFSC   STATUS,Z   ;  
       GOTO    BGN2       ;   
       COMF    PORTB,W    ;  
       GOTO    BGN1       ;   
BGN2:  BCF     FLAGS,BIT2 ;   
       MOVF    KNNEW,W
       ANDLW   0CH        ; 0000.1100   
       BTFSS   STATUS,Z   ;  , W=0
       BSF     FLAGS,BIT2 ;  
       MOVF    KNNEW,W
       ANDLW   70H        ; 0111.0000B - . 
       BTFSC   STATUS,Z   ;  
       GOTO    LIM1       ;   
       BCF     FLAGS,BIT0 ;  0,1
       BCF     FLAGS,BIT1 ; /
       MOVLW   01         ; /
       BTFSC   KNNEW,4    ;  1  10
       GOTO    LIM2       ;  0,1,  .0
       BSF     FLAGS,BIT0 ;  1
       MOVLW   0AH        ; 10
       BTFSC   KNNEW,6    ; 1
       GOTO    LIM10      ; 10
       GOTO    LIM2
LIM10: BSF     FLAGS,BIT1 ;  10
       MOVLW   64H        ; 100
LIM2:  MOVWF   MEMTIME    ; -  0,1
       CALL    INDPRD     ;  
LIM1:  MOVF    KNNEW,W    ; 
       ANDLW   0FH        ; 0000.1111B -     
       BTFSC   STATUS,Z
       GOTO    ZDR0       ;    
       XORWF   KNOLD,W    ;  ,  0
       ANDLW   0FH        ; 0000.1111B - . .    .
       BTFSC   STATUS,Z   ; =1, 
       GOTO    ZDR0
       CALL    RDP1       ;  
       CALL    RDDel      ;    MEM28
ZDR0:  CALL    ZAD10      ;    10ms
;**********************  ************************
;: MEMSZ    (0-255) . . 
;      MEMLZ    (0-255) . . 
;      MEMTZ    (0-31)  . . 
;      MEMTIME  (1, 10, 100) - .  0,1
;
       MOVF    KNNEW,W
       MOVWF   KNOLD      ;  . .  .  .
;       MOVLW   8FH        ;  3- 
;       ANDWF   KNNEW,F    ; x000.xxxx     
       CLRF    MEM20      ;   . . .
       CLRF    MEM21      ; /
       BCF     PORTA,3    ; PORTA,RA3=0
       BSF     STATUS,RP0 ; 1- 
       BCF     TRISA,3    ; PORTA,RA3 - 
       BCF     STATUS,RP0 ; 0 .
       CLRF    TMR0       ;  
       BCF     INTCON,T0IF;  . .,  

; ****** .   *******
;  IZMBEG  IZMEND =(46+MEMSZ*8192+MEMLZ*32+MEMTZ)*MEMTIME
          CLRF    PCLATH     ; 0 .
          MOVF    MEMTIME,W  ; . - .  0,1
          MOVWF   TMP1
          BSF     STATUS,RP0 ; 1 .
IZMBEG:   BSF     TRISA,3    ;  
          BCF     STATUS,RP0 ; 0 .
          GOTO    ZAD01
ZAD00:    GOTO    $+1
          GOTO    $+1
          NOP                ;    1  10 
ZAD01:    INCF    MEMSZ,W
          MOVWF   TMP2       ; . . .+1
          INCF    MEMLZ,W
          MOVWF   TMP3       ; , . .+1
          GOTO    ZAD02
ZAD04:    GOTO    $+1
ZAD03:    GOTO    $+1
          GOTO    $+1
ZAD02:    CALL    IZM5       ; .  .  (10.)
          COMF    PORTB,W    ; . . 0-., 1-.
          XORWF   KNNEW,W    ;   ., W=0
          BTFSS   STATUS,Z   ;  
          GOTO    BEGN       ; ,  
          GOTO    $+1
          GOTO    $+1
          GOTO    $+1
          GOTO    $+1
          NOP                ;   32 
          DECFSZ  TMP3,F     ; . . 
          GOTO    ZAD04      ;   
          DECFSZ  TMP2,F     ; . . 
          GOTO    ZAD03      ;   
          MOVF    MEMTZ,W    ;  . 
          ANDLW   1FH        ; 0001 1111 W=<31
          SUBLW   1FH        ; 31-W-->W
          ADDWF   PCL,F      ; PCL+W-->PCL
          ADDLW   0FFH       ;  31 
          ADDLW   0FFH
          ADDLW   0FFH
          ADDLW   0FFH
          ADDLW   0FFH
          ADDLW   0FFH
          ADDLW   0FFH
          ADDLW   0FFH
          ADDLW   0FFH
          ADDLW   0FFH
          ADDLW   0FFH
          ADDLW   0FFH
          ADDLW   0FFH
          ADDLW   0FFH
          ADDLW   0FFH
          ADDLW   0FFH
          ADDLW   0FFH
          ADDLW   0FFH
          ADDLW   0FFH
          ADDLW   0FFH
          ADDLW   0FFH
          ADDLW   0FFH
          ADDLW   0FFH
          ADDLW   0FFH
          ADDLW   0FFH
          ADDLW   0FFH
          ADDLW   0FFH
          ADDLW   0FFH
          ADDLW   0FFH
          ADDLW   0FFH
          ADDLW   0FFH
          DECFSZ  TMP1,F     ; . - .  0,1
          GOTO    ZAD00
          BSF     PORTA,3    ; PORTA,3=1
          BSF     STATUS,RP0 ; 1 .
          BCF     TRISA,3    ;  
; ******    0100H *******
IZMEND:   BCF     STATUS,RP0 ; 0 .
          CALL    IZM5       ; .  . 
          COMF    PORTB,W    ; . . 0-., 1-.
          XORWF   KNNEW,W    ;   ., W=0
          BTFSS   STATUS,Z   ;  
          GOTO    BEGN       ; ,  
;  .   
       MOVF    TMR0,W
       MOVWF   MEM22         ; .
       CLRF    MEM23         ; . 
TGLE:  DECF    MEM23,F
       BCF     PORTA,3
       BSF     PORTA,3       ;    
       MOVF    MEM22,W       ; . . . .
       SUBWF   TMR0,W
       BTFSC   STATUS,Z
       GOTO    TGLE          ; .  
       BCF     INTCON,T0IF   ;  . .,  
;  
       CLRF    MEM19         ;  . 
       MOVF    MEM28,W
       MOVWF   TMP4          ;  
       BTFSS   FLAGS,BIT2
       GOTO    BDL1          ;  , BT2=0
       CALL    MUL1          ;   
BDL1:  BTFSC   FLAGS,BIT1
       GOTO    BPCH          ; T=10,   
       MOVF    KNNEW,W       ; . 
       ANDLW   03H           ;   
       BTFSC   STATUS,Z
       GOTO    BPCH          ; =0
       CALL    PER1       ;  MEM19-MEM23  MEML7-MEMLB
       CALL    PER2       ;  IF1-IF4  MEM20-MEM23
       BCF     MEM20,7    ;   
       clrf    MEM19
       BTFSS   FLAGS,BIT0 ; 1
       goto    NoMul      ; 0,1 ,   
       MOVLW   0AH        ; 10 -    1
       MOVWF   MEM28      ; 
       CALL    MUL1       ;    10
NoMul: MOVF    MEML7,W    ;  .  
       MOVWF   MEML2      ; MEML7-MEMLB  MEML2-MEML6
       MOVF    MEML8,W    ; /
       MOVWF   MEML3      ; /
       MOVF    MEML9,W    ; /
       MOVWF   MEML4      ; /
       MOVF    MEMLA,W    ; /
       MOVWF   MEML5      ; /
       MOVF    MEMLB,W    ; /
       MOVWF   MEML6      ; /
       BTFSC   IF1,7
       GOTO    VICH       ;  
       CALL    ADD1       ;  
       GOTO    BPCH
VICH:  CALL    SUB1       ;  
BPCH:  MOVF    TMP4,W
       MOVWF   MEM28      ;  
       CALL    TTCH       ;      F
       MOVWF   TMP4       ;  
       CALL    TRN1       ;   2-10 
       call    Tchk       ;    
       CALL    OUTIN      ;   
       MOVF    FLAGS,W
       ANDLW   03         ;  
       BTFSS   STATUS,Z   ; =0,  0,1
       GOTO    BEGN       ; 1  10,  
       MOVLW   CONZAD
       MOVWF   TMP3       ; .   0,1
DOPZAD: COMF    PORTB,W   ; . . 0-., 1-.
        XORWF   KNNEW,W   ;   ., W=0
        BTFSS   STATUS,Z  ;  
        GOTO    BEGN      ; ,  
        CALL    ZAD10     ; 10ms
        DECFSZ  TMP3,F
        GOTO    DOPZAD
        GOTO    BEGN      ;  
;=====================================================
;
;/     
;: MEM20 - MEM21 -   
;      .    .
IZM5:  BTFSS   INTCON,T0IF
       GOTO    IZM2;         
       BCF     INTCON,T0IF;  . 
       INCFSZ  MEM21,F
       GOTO    IZM3;          MEM21
       INCF    MEM20,F
IZM3:  RETURN
IZM2:  NOP
       GOTO    IZM3
;
;******** /  **********
; /  ~10ms
; : TMP1,TMP2,TMP3
ZAD10:    INCF    MEMSZ,W
          MOVWF   TMP1
ZAD101:   CLRF    TMP2
          DECFSZ  TMP2,F
          GOTO    $-1
          DECFSZ  TMP1,F
          GOTO    ZAD101
          RETURN

; /   ~N*10ms
; : W -  *10ms
; : TMP1,TMP2,TMP3
ZAD_N10: movwf   TMP3
         call    ZAD10
         decfsz  TMP3,F
         goto    $-2
         return

;******** /   ************
; : FLAGS  xxxxxx00  - 0,1 
;              xxxxxx01  -   1 
;              xxxxxx1x  -  10 
; : PORTA2 =0  - 0,1 
;            =1  -   1 
;            =Z  -  10 
INDPRD:   BTFSC   FLAGS,BIT1  ; 0,1  1
          GOTO    INDP10      ; 10
          BTFSC   FLAGS,BIT0  ; 0,1
          GOTO    INDP1       ; 1
          BCF     PORTA,LED   ; 0,1
INDP2:    BSF     STATUS,RP0  ; 1 .
          BCF     TRISA,LED   ; PORTA2 - 
INDP3:    BCF     STATUS,RP0  ; 0 .
          RETURN
INDP1:    BSF     PORTA,LED   ; 1
          GOTO    INDP2
INDP10:   BSF     STATUS,RP0
          BSF     TRISA,LED   ; PORTA2 - 
          GOTO    INDP3
;
; ******** /      F ************
; :  MEM19-MEM23  - F
;        MEM28, FLAGS - 
; : W -   - 01-09
;        MEM19-MEM23 - F   
TTCH:   BTFSS    FLAGS,BIT1
        GOTO     TTC1        ; T=1  0,1, BIT1=0
        BTFSS    FLAGS,BIT2  ; T=10
        retlw    07H         ;   T=10
        CALL     DL10
        MOVF     MEM28,W     ; W=Kd
        btfsc    STATUS,Z    ; <>0
        goto     TTC01       ; =0,  256
        SUBLW    .20         ; 20-Kd-->W
        BTFSC    STATUS,C    ;  , >20
        RETLW    08H         ; K=1-20, T=10
TTC01:  CALL     DL10
        RETLW    09H         ; K>20, T=10
TTC1:   BTFSS    FLAGS,BIT0
        GOTO     TTC2        ; T=0,1, Bit0=0
        BTFSS    FLAGS,BIT2  ; T=1
        retlw    04H         ; =1,  
        CALL     DL10
        MOVF     MEM28,W     ; W=Kd
        btfsc    STATUS,Z    ; <>0
        goto     TTC02       ; =0,  256
        SUBLW    .20         ; 20-Kd-->W
        BTFSC    STATUS,C    ;  , >20
        RETLW    05H         ; K=1-20, T=1
TTC02:  CALL     DL10
        RETLW    06H         ; K>20, T=1
TTC2:   BTFSS    FLAGS,BIT2  ; T=0,1
        retlw    01H         ; T=0,1   
        CALL     DL10
        MOVF     MEM28,W     ; W=Kd
        btfsc    STATUS,Z    ; <>0
        goto     TTC03       ; =0,  256
        SUBLW    .20         ; 20-Kd-->W
        BTFSC    STATUS,C    ;  , >20
        RETLW    02H         ; K=1-20, T=0,1
TTC03:  CALL     DL10
        RETLW    03H         ; K>20, T=0,1

;************** /      ***********
;                                         MSB     LSB

;___xxx.xx0,00_KH  0,1s   .    00000000.01000100     00      44
;__xxx.xxx.xx0_Hz    1s   .    00000000.10001000     00      88
;xxx.xxx.xx0,0_Hz   10s   .    00000010.00100010     02      22
;__x.xxx.xx0,0_KH  0,1s  1...20      00000010.00100010     02      22
;_x.xxx.xx0,00_KH    1s  1...20      00000100.01000100     04      44
;x.xxx.xxx.xx0_Hz   10s  1...20      00001000.10001000     08      88
;___xx.xxx.xx0_KH  0,1s 21...256     00000000.10001000     00      88
;_xx.xxx.xx0,0_KH    1s 21...256     00000010.00100010     02      22
;xx.xxx.xx0,00_KH   10s 21...256     00000100.01000100     04      44
;_Hz
;_KH
;_MH
;_GH

;: MEML0...MEML 2-10   
;       .     .
;      TMP4 - 
;: TMP1, TMP2, TMP3, TMP4, StrHi, StrLow

Tchk:   movlw   HIGH TabTchk;  
        movwf   StrHi
        movlw   LOW TabTchk
        movwf   StrLow
        decf    TMP4,W      ;  -1
        movwf   TMP1
        movf    TMP4,W
        movwf   MEMLF       ;    
        bcf     STATUS,C
        rlf     TMP1,W      ;*2
        addwf   StrLow,F
        btfsc   STATUS,C
        incf    StrHi,F
        call    Messeges
        movwf   TMP3        ; .  
        call    Messeges
        movwf   TMP4        ; .  
        clrf    PCLATH
;    
        movlw   MEMLC       ;  . 
        movwf   StrLow      ; 
Tchk02: rrf     TMP3,F
        rrf     TMP4,F      ; C=1 - , =0 - 
        btfss   STATUS,C
        goto    Tchk01      ;  
        movf    StrLow,W
        movwf   FSR
        call    SdvTchk     ; 
        movf    StrLow,W
        movwf   FSR
        movlw   '.'
        movwf   INDF        ;  
Tchk01: decf    StrLow,F    ;  . 
        movf    StrLow,W
        sublw   MEML0
        btfss   STATUS,Z
        goto    Tchk02
;     
        movlw   MEMLB
        movwf   FSR
        movf    INDF,W       ; MEMLB
        xorlw   '.'
        movlw   ','
        btfsc   STATUS,Z
        movwf   INDF
        decf    FSR,F        ; MEMLA
        movf    INDF,W
        xorlw   '.'
        movlw   ','
        btfsc   STATUS,Z
        movwf   INDF
;     
        movlw   MEML0
        movwf   FSR
Tchk05: movf    INDF,W
        movwf   TMP1
        incf    FSR,F
        movf    INDF,W
        decf    FSR,F
        xorlw   ','
        btfsc   STATUS,Z    ; .   ,
        goto    Tchk06      ; ,  
        movf    TMP1,W
        btfsc   STATUS,Z    ;  0
        goto    Tchk03      ; 0
        xorlw   '.'
        btfss   STATUS,Z    ; .
        goto    Tchk06      ;  0   .   
Tchk03: movlw   ' '
        movwf   INDF
Tchk04: incf    FSR,F
        movf    FSR,W
        xorlw   MEMLC
        btfss   STATUS,Z
        goto    Tchk05      ; . 
;  
Tchk06: movlw   MEML0
        movwf   FSR
        clrf    MEMLE       ;  
Tchk08: movf    INDF,W
        xorlw   '.'
        btfsc   STATUS,Z    ;  
        incf    MEMLE,F
        movf    FSR,W
        xorlw   MEMLB
        btfsc   STATUS,Z
        goto    Tchk07      ;  
        incf    FSR,F
        goto    Tchk08
;  
; MEMLF - , MEMLE - - 
; 0 :  4,7,8        - 'H'
;                1,2,3,5,6,9  - 'K'
; 1 :  1,2,3,5,6,9  - 'M'
;                4,7,8        - 'K'
; 2 :  1,2,3,5,6,9  - 'G'
;                4,7,8        - 'M'
; 3 :                    - 'G'
Tchk07: movlw   ' '
        movwf   MEMLD
        call    Letter      ;  
        movwf   MEMLE
        xorlw   'H'
        movlw   'H'
        btfsc   STATUS,Z    ;  'H'
        movlw   'z'         ; 'H'
        movwf   MEMLF
        return

; /   H - K - M - G
; :  MEMLF - 
;        MEMLE - - 
; : W - 
Letter: movf    MEMLF,W     ; 
        sublw   03H         ; 3 - 
        btfss   STATUS,C    ; <=3
        goto    Ltt5        ; >3
        movf    MEMLE,W
        btfsc   STATUS,Z
        retlw   'K'         ;  <=3, 0 
        xorlw   1
        btfsc   STATUS,Z
        retlw   'M'         ;  <=3, 1 
        movf    MEMLE,W
        xorlw   2
        btfsc   STATUS,Z
        retlw   'G'         ;  <=3, 2 
        retlw   'G'         ; >2 
Ltt5:   movf    MEMLF,W     ; 
        sublw   04H         ; 4 - 
        btfss   STATUS,C    ; <=4
        goto    Ltt7        ; >4
        movf    MEMLE,W
        btfsc   STATUS,Z
        retlw   'H'         ;  4, 0 
        xorlw   1
        btfsc   STATUS,Z
        retlw   'K'         ;  4, 1 
        movf    MEMLE,W
        xorlw   2
        btfsc   STATUS,Z
        retlw   'M'         ;  4, 2 
        retlw   'G'         ; >2 
Ltt7:   movf    MEMLF,W     ; 
        sublw   06H         ; 6 - 
        btfss   STATUS,C    ; <=6
        goto    Ltt9        ; >6
        movf    MEMLE,W
        btfsc   STATUS,Z
        retlw   'K'         ;  5,6, 0 
        xorlw   1
        btfsc   STATUS,Z
        retlw   'M'         ;  5,6, 1 
        movf    MEMLE,W
        xorlw   2
        btfsc   STATUS,Z
        retlw   'G'         ;  5,6, 2 
        retlw   'G'         ; >2 
Ltt9:   movf    MEMLF,W     ; 
        sublw   08H         ; 8 - 
        btfss   STATUS,C    ; <=8
        goto    LttC        ; >8
        movf    MEMLE,W
        btfsc   STATUS,Z
        retlw   'H'         ;  7,8, 0 
        xorlw   1
        btfsc   STATUS,Z
        retlw   'K'         ;  7,8, 1 
        movf    MEMLE,W
        xorlw   2
        btfsc   STATUS,Z
        retlw   'M'         ;  7,8, 2 
        retlw   'G'         ; >2 
LttC:   movf    MEMLE,W
        btfsc   STATUS,Z
        retlw   'K'         ;  9, 0 
        xorlw   1
        btfsc   STATUS,Z
        retlw   'M'         ;  9, 1 
        movf    MEMLE,W
        xorlw   2
        btfsc   STATUS,Z
        retlw   'G'         ;  9, 2 
        retlw   'G'         ; >2 

; /  MEML0,MEMLC 
; : FSR -       MEML0...MEMLC
; : TMP1, TMP2
SdvTchk: movf   FSR,W
         sublw  MEML0
         btfsc  STATUS,Z
         return              ;  
         movf   INDF,W
         movwf  TMP1         ;  
SdvTc1:  decf   FSR,F
         movf   INDF,W
         movwf  TMP2         ;  
         movf   TMP1,W
         movwf  INDF         ;    
         movf   FSR,W        ;  
         sublw  MEML0
         btfsc  STATUS,Z
         return              ;  
         movf   TMP2,W
         movwf  TMP1
         goto   SdvTc1

;************** /   *************
;/  5    2-.  2-10 
;: MEM19-MEM23                     :MEML0-MEMLC
;      .  .                            .  .
;: TMP1 - .  
;        TMP2 -  
;        TMP3 -   
;        MEML0 - MEML1 ... MEMLB - MEMLC
TRN1:  BCF     STATUS,C; C=0
       MOVLW   .13;       -  -
       MOVWF   TMP2;     
       MOVLW   MEMLC;    . .  -
       MOVWF   FSR
TRN2:  CALL    DL10;       10
       MOVF    TMP3,W;  -->W
       MOVWF   INDF
       DECF    FSR,F;    FSR-1-->FSR
       DECFSZ  TMP2,F;   
       GOTO    TRN2
       RETURN
;
;/  5    10
;: MEM19-MEM23 -    :MEM19-MEM23  - 
;      .  .                    .  .
;      TMP1 -                   TMP3  - 
DL10:  CLRF    TMP3;     .  
       MOVLW   28H;      - .
       MOVWF   TMP1;      
DEL3:  CALL    SDV2;      4-    
       RLF     TMP3,F
       MOVLW   0AH;      -->W
       SUBWF   TMP3,W;  MEM19-W-->W,  , =0
       BTFSC   STATUS,C;  =0,  ()
       MOVWF   TMP3;    
       DECFSZ  TMP1,F;   
       GOTO    DEL3;      40 
       CALL    SDV2;  4   1 .   . . 
       RETURN
SDV2:  RLF     MEM23,F
       RLF     MEM22,F
       RLF     MEM21,F
       RLF     MEM20,F
       RLF     MEM19,F
       RETURN
;
;/  5  
;: MEM19 - MEM23 - 1- 
;      MEML2 - MEML6 - 2-  ( )
;:MEM19 - MEM23 -   
;      .    .
SUB1:  MOVF    MEML6,W;   .  2- 
       SUBWF   MEM23,F;    . 
       MOVF    MEML5,W;   . 2 
       BTFSS   STATUS,C
       INCFSZ  MEML5,W;     (=0)
       SUBWF   MEM22,F;      (=1)
       MOVF    MEML4,W
       BTFSS   STATUS,C
       INCFSZ  MEML4,W
       SUBWF   MEM21,F
       MOVF    MEML3,W
       BTFSS   STATUS,C
       INCFSZ  MEML3,W
       SUBWF   MEM20,F
       MOVF    MEML2,W
       BTFSS   STATUS,C
       INCFSZ  MEML2,W
       SUBWF   MEM19,F;     =0
       BTFSC   STATUS,C;    
       RETLW   00;        2-  < 1-
       COMF    MEM23,F;   2-  > 1-
       COMF    MEM22,F
       COMF    MEM21,F
       COMF    MEM20,F
       COMF    MEM19,F
       MOVLW   01
       ADDWF   MEM23,F;   +1
       BTFSC   STATUS,C;  ,  =0
       ADDWF   MEM22,F;    
       BTFSC   STATUS,C
       ADDWF   MEM21,F
       BTFSC   STATUS,C
       ADDWF   MEM20,F
       BTFSC   STATUS,C
       ADDWF   MEM19,F
       RETLW   01;       2-  > 1-
;
;/  5  
;: MEM19 - MEM23 - 1- 
;      MEML2 - MEML6 - 2-  ( )
;:MEM19 - MEM23 - , =1  
;      .    .
ADD1:  MOVF    MEML6,W;    .  2- 
       ADDWF   MEM23,F;     . 
       MOVF    MEML5,W;    .  2- 
       BTFSC   STATUS,C
       INCFSZ  MEML5,W;     
       ADDWF   MEM22,F;      
       MOVF    MEML4,W
       BTFSC   STATUS,C
       INCFSZ  MEML4,W
       ADDWF   MEM21,F
       MOVF    MEML3,W
       BTFSC   STATUS,C
       INCFSZ  MEML3,W
       ADDWF   MEM20,F
       MOVF    MEML2,W
       BTFSC   STATUS,C
       INCFSZ  MEML2,W
       ADDWF   MEM19,F
       RETURN
;
;/  4-    
;: MEM20 - MEM23 - 
;      MEM28 -   =0,  256
;:MEM19 - MEM23 - 
;      .    .
;      MEML3 - MEML6 -  
;      TMP1  - 
;      MEM18 - . 
MUL1:  CLRF    MEM18
       CLRF    MEM19    ; . =0
       clrf    MEML2    ; /
       CALL    PER3     ;    MEML3 - MEML6
       MOVF    MEM28,F
       BTFSC   STATUS,Z ;   0
       GOTO    MUL7     ; =0,  256
       MOVLW   08       ;   
       MOVWF   TMP1
MUL2:  RRF     MEM28,F  ; 
       BTFSC   STATUS,C
       GOTO    MUL3     ; C=1
       DECFSZ  TMP1,F   ; 
       GOTO    MUL2     ;    
       RETURN
MUL3:  BCF     STATUS,C ; C=0
       GOTO    MUL5
MUL4:  RRF     MEM28,F  ;  
       BTFSC   STATUS,C
       CALL    ADD1     ; C=1,  5- . 
MUL5:  RRF     MEM19,F
       RRF     MEM20,F
       RRF     MEM21,F
       RRF     MEM22,F
       RRF     MEM23,F
       RRF     MEM18,F
       DECFSZ  TMP1,F   ; 
       GOTO    MUL4     ;    
MUL7:  MOVLW   08;    MEM19<-MEM20<-MEM21<-MEM22<-MEM23<-MEM18
       MOVWF   TMP1     ;   \-----------------------------------^
MUL6:  RLF     MEM18,F
       RLF     MEM23,F
       RLF     MEM22,F
       RLF     MEM21,F
       RLF     MEM20,F
       RLF     MEM19,F
       DECFSZ  TMP1,F
       GOTO    MUL6
       RETURN

;/  19 - 23  L7 - LB
PER1:  MOVF    MEM19,W
       MOVWF   MEML7
       MOVF    MEM20,W
       MOVWF   MEML8
       MOVF    MEM21,W
       MOVWF   MEML9
       MOVF    MEM22,W
       MOVWF   MEMLA
       MOVF    MEM23,W
       MOVWF   MEMLB
       RETURN

;/  IF1-IF4  MEM20-MEM23
PER2:  MOVF    IF1,W
       MOVWF   MEM20
       MOVF    IF2,W
       MOVWF   MEM21
       MOVF    IF3,W
       MOVWF   MEM22
       MOVF    IF4,W
       MOVWF   MEM23
       RETURN

;/  20 - 23  L3 - L6
PER3:  MOVF    MEM20,W
       MOVWF   MEML3
       MOVF    MEM21,W
       MOVWF   MEML4
       MOVF    MEM22,W
       MOVWF   MEML5
       MOVF    MEM23,W
       MOVWF   MEML6
       RETURN

; ************* /   EEPROM *****************
; /   EEPROM
; : W - ,  0 .
; : W - 
RD01:   BSF      STATUS,RP0;    1- .
        MOVWF    EEADR;         
        BSF      EECON1,RD;     
        MOVF     EEDATA,W;      
        BCF      STATUS,RP0;    0 .
        RETURN
;
; /   
; : MEMSZ (0-255) . . 
;        MEMLZ (0-255) . . 
;        MEMTZ (0-31)  . . 
RDB1:   MOVLW    02;           . . .
        CALL     RD01
        MOVWF    MEMSZ
        MOVLW    03
        CALL     RD01
        MOVWF    MEMLZ
        MOVLW    04
        CALL     RD01
        MOVWF    MEMTZ
        RETURN
;
; /    EEPROM
; : KNNEW - 2 .  -  
; : IF1 - IF4 - 
;         .   .
; : TMP1
RDP1:   CALL     RSAD
        btfss    STATUS,Z  ; =0
        goto     RDP12     ; <>0, 
        clrf     IF1
        clrf     IF2
        clrf     IF3
        clrf     IF4
        return
RDP12:  CALL     RD01
        MOVWF    IF1
        INCF     TMP1,F
        MOVF     TMP1,W
        CALL     RD01
        MOVWF    IF2
        INCF     TMP1,F
        MOVF     TMP1,W
        CALL     RD01
        MOVWF    IF3
        INCF     TMP1,F
        MOVF     TMP1,W
        CALL     RD01
        MOVWF    IF4
        comf     IF1,F       ; 
        comf     IF2,F
        comf     IF3,F
        comf     IF4,F
        RETURN
;
; /     EEPROM
; : KNNEW - 2 .  -  
; : TMP1 -  .  
RSAD:   MOVF     KNNEW,W
        ANDLW    03H       ;   
        MOVWF    TMP1      ;  
        btfsc    STATUS,Z  ; <>0
        return             ;=0
        bcf      STATUS,C
        rlf      TMP1,F
        rlf      TMP1,F    ;  *4
        MOVLW    04H       ;  (MSB 1 )-4  EEPROM
        ADDWF    TMP1,F    ;  MSB 
        movf     TMP1,W
        RETURN

; /  
; : KNNEW - xxxx.21xx - 
;         <>0
; : MEM28 - Kd
RDDel:  movf     KNNEW,W
        movwf    MEM28
        rrf      MEM28,F
        rrf      MEM28,W
        andlw    03H         ; 0000.00xx
        btfsc    STATUS,Z
        return               ; Kd=0,  
        ADDLW    04H         ; W =   EEPROM -1
        CALL     RD01
        MOVWF    MEM28
        RETURN

; / - . EEPROM
; : TMP3 - 
; W - 
; 0 ., . 
; 
RWR1:   CALL     RD01        ; , W - 
        SUBWF    TMP3,W
        BTFSC    STATUS,Z    ;   
        RETURN               ; , 
; 
        MOVF     TMP3,W
        BSF      STATUS,RP0  ; 1 .
        MOVWF    EEDATA      ;   
        BSF      EECON1,WREN ; . 
        MOVLW    55H
        MOVWF    EECON2
        MOVLW    0AAH
        MOVWF    EECON2
        BSF      EECON1,WR   ;  
        BCF      STATUS,RP0  ; 0 .
WR01:   BTFSS    PIR1,EEIF   ; =1,  
        GOTO     WR01        ; . . 
        BCF      PIR1,EEIF   ;   . .
        BSF      STATUS,RP0  ; 1 .
        BCF      EECON1,WREN ;  
        BCF      STATUS,RP0  ; 0 .
        RETURN               ; 

; /   EEPROM
; : MEM19 - . . EEPROM
;       20 - - 
;       IF1   -   - 
; : TMP1, TMP2, TMP3
;
WRT1:   MOVLW    IF1       ; .  
        MOVWF    FSR
WRT2:   MOVF     INDF,W    ; 
        MOVWF    TMP3
        MOVF     MEM19,W   ;  EEPROM
        CALL     RWR1      ;  
        INCF     MEM19,F   ; . . EEPROM
        INCF     FSR,F     ; . . 
        DECFSZ   MEM20,F   ; 
        GOTO     WRT2
        RETURN

; /  EEPROM  
WRSET:  movlw    LOW TABSET  ; ..  . 
        movwf    StrLow
        movlw    HIGH TABSET ; ..  . 
        movwf    StrHi
        clrf     MEMADR      ;  EEPROM
WRS1:   call     Messeges
        clrf     PCLATH
        movwf    TMP3        ; 
        movf     MEMADR,W    ;  EEPROM
        CALL     RWR1        ;   EEPROM
        INCF     MEMADR,F    ; . 
        BTFSS    MEMADR,3    ;  8 
        GOTO     WRS1
        RETURN

;**************** /    ****************
; /  LCD
; : TMP1,TMP2,TMP3,TMP4
LCDInit:    bsf     STATUS,RP0
            movlw   00FH       ; 0000.1111
            movwf   TRISB      ; PORTB,RA4-RA7 - OUT
            bcf     STATUS,RP0
            movlw   .25
            call    ZAD_N10    ; 250ms
            movlw   03
            movwf   TMP4
LCDIn1:     movlw   03H
            call    LCDcomIN   ;  3H, 3H, 3H
            movlw   .4
            call    ZAD_N10    ; 40ms
            decfsz  TMP4,F
            goto    LCDIn1
            movlw   02H        ;  4 
            call    LCDcomIN
            movlw   28H        ; /
            call    LCDcom
            movlw   08H
            call    LCDcom
            movlw   01H
            call    LCDcom
            movlw   .4
            call    ZAD_N10    ; 40ms
            movlw   06H
            call    LCDcom     ;   
            movlw   0CH
            call    LCDcom     ; . , . 
            bsf     STATUS,RP0
            movlw   0FFH       ; 1111.1111
            movwf   TRISB      ; PORTB - IN
            bcf     STATUS,RP0
            return

; /    
; : ..W - 
; : TMP1,TMP2
LCDcomIN:   bcf     PIN_A0LCD   ; A0=0, 
            movwf   TMP1
            swapf   TMP1,W
            andlw   0F0H        ; xxxx.0000
            movwf   PORTB       ;  DB0-DB3  RB4-RB7
            call    Enbl
            return

; /  
LCDclear:   bsf     STATUS,RP0
            movlw   00FH       ; 0000.1111
            movwf   TRISB      ; PORTB,RA4-RA7 - OUT
            bcf     STATUS,RP0
            movlw   01
            call    LCDcom     ;  .
            movlw   .5
            call    ZAD_N10    ; 50ms
            bsf     STATUS,RP0
            movlw   0FFH       ; 1111.1111
            movwf   TRISB      ; PORTB - IN
            bcf     STATUS,RP0
            return

; /    LCD
; : W - 
; : TMP1,TMP2
LCDcom:     bcf     PIN_A0LCD  ; A0=0, 
            goto    LCDdat1

; /    LCD
; : W - 
; : TMP1,TMP2
LCDdata:    bsf     PIN_A0LCD  ; A0=1, 
LCDdat1:    movwf   TMP1       ;  
            andlw   0F0H       ; xxxx.0000
            movwf   PORTB      ; . 
            call    Enbl
            swapf   TMP1,W
            andlw   0F0H       ; xxxx.0000
            movwf   PORTB      ; . 
            call    Enbl
            movf    TMP1,W     ; . 
            return

; /   
Enbl:       bsf     PIN_ELCD   ; E=1
            movf    MEMSZ,W    ; 0CH  4 
            movwf   TMP2       ; 
            sublw   0DH        ; 0DH - MEMSZ
            btfsc   STATUS,C   ; MEMSZ > 0DH
            goto    Enl1       ; MEMSZ <= 0DH, F <~5
            goto    $+1        ; +18 
            goto    $+1
            goto    $+1
            goto    $+1
            goto    $+1
            goto    $+1
            goto    $+1
            goto    $+1
            goto    $+1
Enl1:       bcf     PIN_ELCD   ; E=0
            nop
            decfsz  TMP2,F
            goto    $-2        ;  ~50mks
            return

; /   .   FLASH  
; : StrHi,StrLow -   
;           0 -   
; : TMP1,TMP2,TMP3,TMP4
Out1Str:    bsf     STATUS,RP0
            movlw   00FH       ; 0000.1111
            movwf   TRISB      ; PORTB,RA4-RA7 - OUT
            bcf     STATUS,RP0
            movlw   080H       ;    1- 
            call    LCDcom
 if Type == 1
;-------  16x1 --------
            movlw   .8         ;  16x1
;-------------------------
 else
;-------  16x2 --------
            movlw   .16
;-------------------------
 endif
            movwf   TMP4       ;  
OutStr01:   call    Messeges   ;   
            clrf    PCLATH
            andlw   0FFH       ;   0
            btfsc   STATUS,Z   ;  , 
            goto    OutStrEnd  ; 
            call    LCDdata    ;  
            decfsz  TMP4,F
            goto    OutStr01   ; . 
 if Type == 1
;-------  16x1 --------
            movlw   0C0H       ;    2- 
            call    LCDcom
            movlw   .8         ;  16x1
            movwf   TMP4       ;  
OutStr02:   call    Messeges   ;   
            clrf    PCLATH
            andlw   0FFH       ;   0
            btfsc   STATUS,Z   ;  , 
            goto    OutStrEnd  ; 
            call    LCDdata    ;  
            decfsz  TMP4,F
            goto    OutStr02   ; . 
;-------------------------
 endif
OutStrEnd:  bsf     STATUS,RP0
            movlw   0FFH       ; 1111.1111
            movwf   TRISB      ; PORTB - IN
            bcf     STATUS,RP0
            return

;******** /     **********
; : MEML0 - MEMLF   
;  TMP1, TMP2, TMP3, TMP4
OUTIN:      bsf     STATUS,RP0
            movlw   00FH       ; 0000.1111
            movwf   TRISB      ; PORTB,RA4-RA7 - OUT
            bcf     STATUS,RP0
            movlw   080H       ;    1- 
            call    LCDcom
 if Type == 1
;-------  16x1 --------
            movlw   .8         ;  16x1
;-------------------------
 else
;-------  16x2 --------
            movlw   .16
;-------------------------
 endif
            movwf   TMP4       ;  
            movlw   MEML0      ;  
            movwf   FSR
OutIN01:    movf    INDF,W
            call    PkdDig     ;  
            call    LCDdata    ;  
            incf    FSR,F
            decfsz  TMP4,F
            goto    OutIN01    ; . 
 if Type == 1
;-------  16x1 --------
            movlw   0C0H       ;    2- 
            call    LCDcom
            movlw   .8         ;  16x1
            movwf   TMP4       ;  
OutIN02:    movf    INDF,W
            call    PkdDig     ;  
            call    LCDdata    ;  
            incf    FSR,F
            decfsz  TMP4,F
            goto    OutIN02    ; . 
;-------------------------
 endif
            bsf     STATUS,RP0
            movlw   0FFH       ; 1111.1111
            movwf   TRISB      ; PORTB - IN
            bcf     STATUS,RP0
            return

; /      
; :  W - 
; : W -  
; : TMP1
PkdDig:     movwf   TMP1       ;  
            sublw   09H        ; 09 - W
            btfss   STATUS,C
            goto    PkdD1      ; w > 09 -  
            movlw   30H
            addwf   TMP1,F
PkdD1:      movf    TMP1,W
            return

; *************    *********
;  
NSTR:   MOVLW    01        ;    
        CALL     RD01      ; , W- 
        IORLW    0FCH      ; 11111100B,  
        MOVWF    FLAGS     ; 
        call     LCDclear  ;  
        CALL     INPR;         . 
        CALL     INDPRD    ;  
        CALL     OKN1      ; . . 
PRS4:   CALL     ZADKN     ;   
        BTFSC    KNNEW,6   ; SEL  
        GOTO     ZAP1      ; 
        BTFSS    KNNEW,5   ;  UP
        GOTO     PR20      ;   UP
        CLRW               ;  10 =FF
        INCFSZ   FLAGS,F
        MOVLW    0FFH      ;  10 =FE
        SUBWF    FLAGS,W
        MOVLW    0FCH
        BTFSC    STATUS,Z  ; (FLAGS)  FE  FF
        MOVWF    FLAGS     ; (FLAGS) = FC
PR22:   CALL     INPR      ;  
        CALL     INDPRD    ;  
        GOTO     PRS4      ; 
PR20:   BTFSS    KNNEW,4   ;  DWN
        GOTO     PRS4      ;   DWN
        DECF     FLAGS,F
        MOVLW    0FCH
        SUBWF    FLAGS,W
        MOVLW    0FEH
        BTFSS    STATUS,C  ;  
        MOVWF    FLAGS     ; , (FLAGS)=FE
        GOTO     PR22
;  
ZAP1:   MOVF     FLAGS,W
        IORLW    0FCH      ;  
        MOVWF    TMP3      ; 
        MOVLW    01        ; 
        CALL     RWR1      ;  .
        CALL     OKN1      ; . . 
;
;  
        movf     KNNEW,W   ;   
        movwf    MEM28
        rrf      MEM28,F
        rrf      MEM28,W
        andlw    03H       ; 0000.00xx -  
        BTFSC    STATUS,Z  ; N  0,  
        GOTO     VVZN0     ;  
        MOVWF    KNOLD     ;   .
        CALL     RDDel     ;    MEM28
KD01:   MOVF     MEM28,W
        CALL     VE01      ;    . .
        MOVF     KNOLD,W   ;  
        MOVWF    MEMLB
; Kd=
        movlw   'K'
        movwf   MEML9
        movlw   'd'
        movwf   MEMLA
        movlw   '='
        movwf   MEMLC
        CALL     OUTIN
KD02:   CALL     ZADKN     ;   
        BTFSC    KNNEW,6   ; SEL  
        GOTO     ZAP2      ; 
        BTFSS    KNNEW,5   ;  UP
        GOTO     KDDN      ;  . UP
        INCF     MEM28,F
        GOTO     KD01      ; 
KDDN:   BTFSS    KNNEW,4   ;  DWN
        GOTO     KD02      ;  . 
        DECF     MEM28,F
        GOTO     KD01
ZAP2:   MOVF     MEM28,W
        MOVWF    TMP3      ; 
        MOVF     KNOLD,W   ;  
        ADDLW    04H       ; W =    EEPROM
        CALL     RWR1      ; 
        CALL     OKN1

;   
VVZN0:  COMF     PORTB,W
        ANDLW    03H        ;  N 
        BTFSC    STATUS,Z   ; N   0
        GOTO     TEST       ; N  = 0, 
        MOVWF    KNNEW
        CALL     RDP1       ;    IF1-IF3
        MOVF     KNNEW,W    ; N 
        movwf    MEMLF
        MOVLW    'F'        ; F
        MOVWF    MEMLE
        MOVLW    'I'        ; I
        MOVWF    MEMLD
        movlw    ' '
        movwf    MEMLB
        movwf    MEMLA
        movwf    MEML9
        movwf    MEML8
        movwf    MEML7
        movwf    MEML6
        movwf    MEML5
        movwf    MEML4
        movwf    MEML3
        movwf    MEML2
        movwf    MEML1
        movwf    MEML0
VVZN:   MOVLW    '+'        ; +
        BTFSC    IF1,7      ; Bit7=0, +
        MOVLW    '-'        ; -, Bit7=1, -
        MOVWF    MEMLC
        CALL     OUTIN
VVZN1:  CALL     ZADKN      ;   
        BTFSC    KNNEW,6    ; SEL  
        GOTO     VPCH       ;  
        BTFSC    KNNEW,5    ;   UP
        BCF      IF1,7      ; . UP, - +
        BTFSC    KNNEW,4    ;  . DWN
        BSF      IF1,7
        ANDLW    70H        ; 0111.0000B  
        BTFSC    STATUS,Z   ;  
        GOTO     VVZN1      ;   
        GOTO     VVZN

;  
VPCH:   MOVWF    KNOLD      ;   
        CALL     OKN1
        CLRF     KNNEW      ;   
VPH1:   CLRF     MEM29      ; CONST  
        CLRF     MEM30
        MOVLW    01         ; 10
        MOVWF    MEM31
VPH4:   MOVLW    05H        ; -    CONST
        MOVWF    MEM28
VPH3:   clrf     MEML2      ; . 
        CLRF     MEML3      ; /
        MOVF     MEM29,W;     CONST  MEML2-MEML6
        MOVWF    MEML4
        MOVF     MEM30,W
        MOVWF    MEML5
        MOVF     MEM31,W
        MOVWF    MEML6
        CLRF     MEM19      ; .  
        CALL     PER2       ;  IF1-IF4  MEM20-MEM23
        BCF      MEM20,7    ;   
        BTFSC    KNNEW,6    ; SEL  
        GOTO     ZAP3       ;  SEL
        BTFSC    KNNEW,5    ;   UP
        CALL     ADD1CI     ; . UP,    CONST c   max
        BTFSC    KNNEW,4    ;   DWN
        CALL     SUB1CI     ; . DWN,  CONST c   '-'
VPH6:   MOVF     IF1,W      ; .  
        ANDLW    80H        ;  
        BCF      MEM20,7    ;  .  
        IORWF    MEM20,W    ;  
        MOVWF    IF1
        MOVF     MEM21,W
        MOVWF    IF2
        MOVF     MEM22,W
        MOVWF    IF3
        MOVF     MEM23,W
        MOVWF    IF4
        CALL     TRN1
        movlw    1          ; 
        movwf    TMP4
        call     Tchk       ;    
        movf     MEML2,W
        xorlw    ' '
        btfss    STATUS,Z   ;   
        goto     VPH5
        MOVLW    'I'
        MOVWF    MEML0
        MOVLW    'F'
        MOVWF    MEML1
        MOVLW    ' '
        MOVWF    MEML2
VPH5:   CALL     OUTIN      ;   
        CALL     ZADKN      ;   
        MOVLW    70H        ; 0111.0000B, . 
        ANDWF    KNNEW,W
        BTFSC    STATUS,Z   ; W  0,  
        GOTO     VPH1       ;   
        BTFSC    KNNEW,6    ; SEL  
        GOTO     ZAP3       ;  SEL
        DECFSZ   MEM28,F    ;  
        GOTO     VPH3       ;  
        BCF      STATUS,C
        RLF      MEM31,F    ;  CONST
        RLF      MEM30,F
        rlf      MEM29,F
        movf     MEM29,W
        sublw    07H        ; 07-(.  .)
        BTFSC    STATUS,C   ; (.  .) > 07,  CONST
        GOTO     VPH4       ; , . .
        rrf      MEM29,F
        RRF      MEM30,F
        RRF      MEM31,F
        GOTO     VPH4
;  
ZAP3:   MOVF     KNOLD,W
        MOVWF    KNNEW       ; .  ,  .
        CALL     RSAD        ;  
        MOVWF    MEM19       ;  
        MOVLW    04
        MOVWF    MEM20       ; - 
        comf     IF1,F       ; 
        comf     IF2,F
        comf     IF3,F
        comf     IF4,F
        CALL     WRT1;         
        CALL     OKN1

;     
TEST:   movlw   HIGH Setup
        movwf   StrHi
        movlw   LOW Setup
        movwf   StrLow
        call    Out1Str    ;  SETUP
        MOVLW    00
        MOVWF    MEM28     ; 
TS01:   CALL     ZAD10     ; 10ms
        COMF     PORTB,W   ; 
        MOVWF    KNNEW
        BTFSC    KNNEW,6   ;  . SEL
        GOTO     VPFOP     ; . SEL
        DECFSZ   MEM28,F   ; 
        GOTO     TS01      ; 
KONEC:  CALL     OKN1
        call     LCDclear
        GOTO     INIT      ; ,   SEL
;   
VPFOP:  CALL     OKN1
        CALL     RDB1      ;    MEMSZ, MEMLZ. MEMTZ
        MOVF     MEMSZ,W   ;   
        MOVWF    IF1       ; 
        MOVF     MEMLZ,W
        MOVWF    IF2
        CLRF     IF3       ;  . .
        BCF      STATUS,C
        MOVLW    03
        MOVWF    TMP1      ;  
        RRF      IF1,F
        RRF      IF2,F
        RRF      IF3,F
        DECFSZ   TMP1,F
        GOTO     $-4        ;    3 
        MOVF     MEMTZ,W
        ANDLW    1FH        ;  3 . 
        IORWF    IF3,F      ;  3- . 
        CLRF     KNNEW      ;   
VPFOP1: CLRF     MEM30      ; CONST  F 
        MOVLW    01H
        MOVWF    MEM31
VPFOP4: MOVLW    05H        ; -    CONST
        MOVWF    KNOLD
VPFOP3: CLRF     MEML2      ; . 
        clrf     MEML3      ; /
        clrf     MEML4      ; /
        MOVF     MEM30,W    ;  CONST  MEML5-MEML6
        MOVWF    MEML5
        MOVF     MEM31,W
        MOVWF    MEML6
        CLRF     MEM19
        clrf     MEM20
        movf     IF1,W      ;  IF1-IF3  MEM21-MEM23
        movwf    MEM21
        movf     IF2,W
        movwf    MEM22
        movf     IF3,W
        movwf    MEM23
        BTFSC    KNNEW,6    ; SEL  
        GOTO     ZAPFOP     ;  SEL
        BTFSC    KNNEW,5    ;   UP
        CALL     ADD1C      ; . UP,   CONST
        BTFSC    KNNEW,4    ;   DWN
        CALL     SUB1C      ; . DWN,  CONST
        clrf     MEM19      ; .  =0
        CLRF     MEM20      ; /
        movf     MEM21,W    ;  MEM21-MEM23  IF1-IF3
        movwf    IF1
        movf     MEM22,W
        movwf    IF2
        movf     MEM23,W
        movwf    IF3
;   .  F     
        CLRF     MEML2
        CLRF     MEML3
        CLRF     MEML4
        CLRF     MEML5
        MOVLW    DOPCON     ; 46 -   . .
        MOVWF    MEML6
        CALL     ADD1       ; +46
        MOVLW    28H
        MOVWF    MEM28
        CALL     MUL1       ;   40 = .   
        CALL     TRN1
        movlw    4          ; 
        movwf    TMP4
        call     Tchk       ;    
        movf     MEML2,W
        xorlw    ' '
        btfss    STATUS,Z   ;   
        goto     VPFP5
        MOVLW    'F'
        MOVWF    MEML0
        MOVLW    'x'
        MOVWF    MEML1
        MOVLW    ' '
        MOVWF    MEML2
VPFP5:  CALL     OUTIN      ;   
        CALL     ZADKN      ;   
        COMF     PORTB,W    ; 
        MOVWF    KNNEW
        MOVLW    70H        ; 0111.0000B, . 
        ANDWF    KNNEW,W
        BTFSC    STATUS,Z   ; W  0,  
        GOTO     VPFOP1     ;   
        BTFSC    KNNEW,6    ; SEL  
        GOTO     ZAPFOP     ;  SEL
        DECFSZ   KNOLD,F    ;  
        GOTO     VPFOP3     ;  
        BCF      STATUS,C
        RLF      MEM31,F    ;  CONST
        RLF      MEM30,F
        movf     MEM30,W
        andlw    0F0H       ; xxxx.0000
        BTFSC    STATUS,Z   ; 0001.xxxx -  CONST
        GOTO     VPFOP4     ; , . .
        RRF      MEM30,F
        RRF      MEM31,F    ;  
        GOTO     VPFOP4
ZAPFOP: MOVF     IF3,W      ; .  .
        ANDLW    1FH        ;  3 . 
        MOVWF    TMP2       ; 
        BCF      STATUS,C
        MOVLW    03
        MOVWF    TMP1      ;  
        RLF      IF3,F
        RLF      IF2,F
        RLF      IF1,F
        DECFSZ   TMP1,F
        GOTO     $-4        ;    3 
        MOVF     TMP2,W
        MOVWF    IF3
        MOVLW    02        ; . EEPROM
        MOVWF    MEM19
        MOVLW    03        ; - 
        MOVWF    MEM20
        CALL     WRT1      ; 
        GOTO     KONEC     ; 

; /     max    
ADD1C:  movf     MEM21,W   ; .   F
        sublw    08H       ; 8-MSB
        btfsc    STATUS,C  ; MSB>8,  
        call     ADD1
        return

; /     min    
SUB1C:  movf     MEM21,W   ; .   F
        btfss    STATUS,Z  ; =0
        goto     SBC01     ; MSB <>0
        btfss    MEM22,7   ; >8000
        return             ; <8000,  
SBC01:  call     SUB1
        return

; /     max   
ADD1CI: movf     MEM20,W    ;    ~1.000.000,00
        sublw    05H        ; 5 - (MSB)
        btfsc    STATUS,C   ; > ~1.000.000,00
        call     ADD1       ; <
        return

; /      '-'   
SUB1CI: call     SUB1
        xorlw    00H
        btfsc    STATUS,Z   ; 2-  > 1-,  =0
        return
        clrf     MEM19
        clrf     MEM20
        clrf     MEM21
        clrf     MEM22
        clrf     MEM23
        return
;
;/    
ZADKN:  COMF     PORTB,W
        MOVWF    KNNEW     ; . 
        MOVLW    CONZAD    ; . 
        MOVWF    TMP3
ZADKN2: CALL     ZAD10     ; 10ms
        COMF     PORTB,W
        XORWF    KNNEW,W
        BTFSS    STATUS,Z  ;  
        GOTO     ZADKN1    ; , 
        DECFSZ   TMP3,F
        GOTO     ZADKN2
ZADKN1: CALL     ZAD10
        COMF     PORTB,W
        MOVWF    KNNEW
        RETURN

; /   1, 0.1  10
; : FLAGS - 
INPR:   MOVLW    0FDH      ; 1
        SUBWF    FLAGS,W
        BTFSS    STATUS,Z  ; 1
        GOTO     PR01      ;  1
        movlw    HIGH TabLim1
        movwf    StrHi
        movlw    LOW TabLim1
        movwf    StrLow
        goto     Out1Str
PR01:   MOVLW    0FCH;       0.1
        SUBWF    FLAGS,W
        BTFSS    STATUS,Z;   0.1
        GOTO     PR10;        1,  0.1,  10
        movlw    HIGH TabLim01
        movwf    StrHi
        movlw    LOW TabLim01
        movwf    StrLow
        goto     Out1Str
PR10:   movlw    HIGH TabLim10
        movwf    StrHi
        movlw    LOW TabLim10
        movwf    StrLow
        goto     Out1Str

; /      
; : W - ,  W=0, Kd=256
VE01:   MOVWF    MEM23
        MOVF     MEM23,F
        MOVLW    01       ;  =0,  256
        BTFSS    STATUS,Z ; Kd=0
        CLRW
        MOVWF    MEM22
        CLRF     MEM21
        CLRF     MEM20
        clrf     MEM19
        CALL     TRN1
;     
        movlw   MEML0
        movwf   FSR
VE011:  movf    INDF,F
        movlw   ' '
        btfss   STATUS,Z    ; 0
        goto    VE012       ;  0,   
        movwf   INDF
        incf    FSR,F
        movf    FSR,W
        xorlw   MEMLC
        btfss   STATUS,Z
        goto    VE011       ; . 
;    
VE012:  movf    MEMLC,W
        movwf   MEMLF
        movf    MEMLB,W
        movwf   MEMLE
        movf    MEMLA,W
        movwf   MEMLD
        RETURN

; /   
OKN1:   MOVLW    00       ; -  . 
        MOVWF    TMP4     ; 
OKN2:   COMF     PORTB,W
        ANDLW    70H      ;  3- 
        BTFSS    STATUS,Z ;   
        GOTO     OKN1     ;  
        DECFSZ   TMP4,F
        GOTO     OKN2     ;  256 
        RETURN            ; ,   

; /    
; : StrHi,StrLow -   
; : W - 
Messeges:   movf    StrHi,W
            movwf   PCLATH
            incf    StrLow,F
            btfsc   STATUS,Z
            incf    StrHi,F
            decf    StrLow,W
            movwf   PCL        ;  

;     
TabLim01:  DT "    Time=0,1 sec",0
TabLim1:   DT "    Time=1 sec  ",0
TabLim10:  DT "    Time=10 sec ",0

;     EEPROM  
TABSET:    DT 0FFH,0FDH      ;  .,  1,
           DT 00CH,033H,012H ; MSB, LSB,  . .
           DT 00AH,008H,080H ; Kd=10, 8, 128

;   
; MSB,LSB  1 - 
TabTchk:   DT  00H,44H,02H,22H,00H,88H ; 0,1s:  . 1-20  >20
           DT  00H,88H,04H,44H,02H,22H ;   1s:  . 1-20  >20
           DT  02H,22H,08H,88H,04H,44H ;  10s:  . 1-20  >20

;   Setup
Setup:     DT "---- SETUP -----",0

; 
Zastawka:  DT "v 3.1 by RA4NAL",0

;    
ConstErr:  DT "Fx set 4 MHz",0

           END

